/****************************************************************************
*
*     Module Filename:  User_Actions_API.h
*     Module Name:      User Actions API
*     Description:      User Interface Manager API for handling user actions
*
*	  Author:           Chris Gordon-Smith
*
*     Copyright (C) 2007, 2008 Chris Gordon-Smith
*     Email: See http://www.simsoup.info/
*
*     This program is free software; you can redistribute it and/or modify it
*     under the terms of the GNU General Public License as published by the
*     Free Software Foundation; either version 2 of the License, or (at your
*     option) any later version.
*
*     This program is distributed in the hope that it will be useful, but
*     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
*     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
*     for more details.
*
*     You should have received a copy of the GNU General Public License along
*     with this program; if not, write to the Free Software Foundation, Inc.,
*     59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
*     See the file Licence.txt for a copy of the GNU General Public License.
*
*      Amendment History:- 
*
*              Version	  Date                        Update Description
*              =======    ===========                 ==================
*
*
*
*
****************************************************************************/

#ifndef User_Actions_API_H
#define User_Actions_API_H

class  MainForm;
class  Form_Help;
class  Form_Simulation_Statistics;
class  Form_Simulation_Control;
class  TForm__View_Chemistry;
class  TForm__View_Reactor;
class  Form_System_Monitor;

class   User_Actions_API

{
    public:

        static  void Initialise_API();

//      Form_Help Functions

        class Form_Help_
        {
            friend  class User_Actions_API;
            public:
                static void Show_Help_Text();
        };

//      Form_Simulation_Control Functions

        class Form_SimCtrl
        {
            friend  class User_Actions_API;
            public:
//                static void New_Scenario(bool  Warn_User);
        };

//      Form_Simulation_Statistics Functions

        class Form_SimStats
        {
            friend  class User_Actions_API;
            public:
                static void ListView_Group_DblClick();
                static void ListView_Series_DblClick();
                static void ListView_SerList_Select();
                static void Page_Select();
        };

//      Form_System_Monitor Functions

        class Form_SysMon
        {
            friend  class User_Actions_API;
            public:
                static void Page_Select();
        };

//      Form_View_Chemistry Functions

        class Form_ViewChem
        {
            friend  class User_Actions_API;
            public:
                static void Notify_MolType_ListView_Selection(void*  Data_Ptr);
        };

//      Form_View_Reactor Functions

        class Form_ViewReactor
        {
            friend  class User_Actions_API;
            public:
                static void Notify_R_MolType_ListView_Selection(void*  Data_Ptr);
        };

//      MainForm functions

        class  MainForm_
        {
            friend  class User_Actions_API;
            public:
                static  void File_Exit();
                static  bool File_Load_Scenario();
                static  void File_Close_Scenario();
                static  bool Simulation_Go_Click();
                static  void Simulation_Stop_Click();
        };

    private:
        static  MainForm*   MainForm_Ptr;
        static  Form_Help*                   Form_Help_Ptr;
        static  Form_Simulation_Control*     Form_SimCtrl_Ptr;
        static  Form_Simulation_Statistics*  Form_SimStats_Ptr;
        static  TForm__View_Chemistry*       Form_ViewChem_Ptr;
        static  TForm__View_Reactor*         Form_ViewReactor_Ptr;
        static  Form_System_Monitor*         Form_SysMon_Pt;
};
#endif  //User_Actions_API_H  

