/****************************************************************************
*
*	  Header Filename:  System_Monitor.h
*	  Module Name:      System Monitor
*	  Description:      Built in system monitor. Mainly for diagnostic purposes
*	  Author:           Chris Gordon-Smith
*
*     Copyright (C) 2005, 2006, 2008 Chris Gordon-Smith
*     Email: See http://www.simsoup.info/
*
*     This program is free software; you can redistribute it and/or modify it
*     under the terms of the GNU General Public License Version 2, as published 
*     by the Free Software Foundation.
*
*     This program is distributed in the hope that it will be useful, but
*     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
*     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
*     for more details.
*
*     You should have received a copy of the GNU General Public License along
*     with this program; if not, write to the Free Software Foundation, Inc.,
*     59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
*     See the file Licence.txt for a copy of the GNU General Public License.
*
*	  Amendment History:-
*
*     Version	  Date                        Update Description
*     =======     ===========                 ==================
*
*
*
*
****************************************************************************/

#ifndef  System_Monitor_H
#define  System_Monitor_H

class   System_Monitor

{
//===== Relationships with other classes ===================================================================

//==========================================================================================================

    public:
        string  Get_Current_Class();
        int     Get_Num_Creates_Current_Class();
        int     Get_Num_Deletes_Current_Class();
        int     Get_Num_Objects_Current_Class();
        bool    Iter_To_First_Class();
        bool    Iter_To_Next_Class();
        void    Object_Creation(string Class_Name);
        void    Object_Deletion(string Class_Name);
        static  System_Monitor*  Get_Ptr();
        static  void  Make();

    private:
        map<string,pair<int,int> >  Object_Statistics;
        map<string,pair<int,int> >::const_iterator Object_Statistics_Iter;
        static System_Monitor*  Instance_Ptr;
};
#endif  //System_Monitor_H
