/****************************************************************************
*
*	  Header Filename:  VCL_Compatibility_Support.h
*	  Module Name:      VCL_Compatibility_Support
*	  Description:      Provides some VCL compatible features without using the VCL.
*                       This is to maximise portability.
*	  Author:           Chris Gordon-Smith
*
*     Copyright (C) 2003, 2004, 2005, 2006, 2008 Chris Gordon-Smith
*     Email: See http://www.simsoup.info/
*
*     This program is free software; you can redistribute it and/or modify it
*     under the terms of the GNU General Public License Version 2, as published 
*     by the Free Software Foundation.
*
*     This program is distributed in the hope that it will be useful, but
*     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
*     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
*     for more details.
*
*     You should have received a copy of the GNU General Public License along
*     with this program; if not, write to the Free Software Foundation, Inc.,
*     59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
*     See the file Licence.txt for a copy of the GNU General Public License.
*
*	  Amendment History:-
*
*		Version	   Date	   			Update Description
*		=======    ===========		==================
*
*
*
*
****************************************************************************/

#ifndef VCL_Compatibility_SupportH
#define VCL_Compatibility_SupportH
 

class VCS_Functions

//   Functions for VCS Compatibility.
//   These functions enable VCL facilities to be used (indirectly) by translation
//   units that do not include vcl.h
{
    public:
        static void Display_Exception_Message(char const* Error_Message__Ptr,char const* Error_Type__Ptr);
};

//----------------------------------------------------------------------------------------------------------
class  VCSList

{
    public:

        int     Add(void*);
        void    Clear();
        int     Count();
        void*   Get_Current_Item();
        void*   Get_Random_Value();
        bool    Iter_To_First();
        bool    Iter_To_Next();
        VCSList() {};
        void    Remove(void*);
        void    Remove_Last();
        void*   Remove_Random_Value();
        void*   Get_Item(int Index);
    private:
        std::vector<void*>  Items;
        std::vector<void*>::iterator  Iterator;
};

//class TListItem;
//template <class T>     // Link a TListItem to the specified object
//inline void Set_List_Item_Data_Ptr(TListItem* TListItem__Ptr, T*  Data_Ptr) //{TListItem__Ptr->Set_Data(static_cast<void*> (Data_Ptr));}

//----------------------------------------------------------------------------------------------------------
#endif  //VCL_Compatibility_SupportH_H

